"use strict";

exports.__esModule = true;
exports.Autocomplete = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _Input = _interopRequireDefault(require("./Input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var propTypes = {
  activeIndexOnInputChange: _propTypes.default.number,
  addClearInput: _propTypes.default.bool,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  clearOnSelect: _propTypes.default.bool,
  clearOnSubmit: _propTypes.default.bool,
  defaultActiveIndex: _propTypes.default.number,
  defaultValue: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  hideDropdownOnSubmit: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  hideResultsTopBorder: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputBorderless: _propTypes.default.bool,
  inputFocusBorderless: _propTypes.default.bool,
  inputOverflowEllipsis: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  inputRemoveMargins: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  maxResults: _propTypes.default.number,
  name: _propTypes.default.string,
  noResultsLabel: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.symbol]),
  onBlur: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onSelect: _propTypes.default.func,
  onSubmit: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.symbol,
  results: _propTypes.default.arrayOf(_propTypes.default.object),
  resultsBorderless: _propTypes.default.bool,
  resultsMaxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsPosition: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsWidth: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  scrollResults: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  small: _propTypes.default.bool,
  subResultPaddingUnits: _propTypes.default.number,
  underlineFocus: _propTypes.default.bool
};

var Autocomplete = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Autocomplete, _Component);

  function Autocomplete(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      activeIndex: props.defaultActiveIndex || -1,
      areResultsVisible: false,
      lastEventType: null,
      value: ''
    };
    return _this;
  }

  var _proto = Autocomplete.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        activeIndexOnInputChange = _this$props.activeIndexOnInputChange,
        addClearInput = _this$props.addClearInput,
        autoFocus = _this$props.autoFocus,
        book = _this$props.book,
        clearOnSelect = _this$props.clearOnSelect,
        clearOnSubmit = _this$props.clearOnSubmit,
        defaultActiveIndex = _this$props.defaultActiveIndex,
        defaultValue = _this$props.defaultValue,
        disabled = _this$props.disabled,
        hideDropdownOnSubmit = _this$props.hideDropdownOnSubmit,
        hideLabel = _this$props.hideLabel,
        hideResultsTopBorder = _this$props.hideResultsTopBorder,
        id = _this$props.id,
        inline = _this$props.inline,
        inputBorderless = _this$props.inputBorderless,
        inputFocusBorderless = _this$props.inputFocusBorderless,
        inputOverflowEllipsis = _this$props.inputOverflowEllipsis,
        inputRef = _this$props.inputRef,
        inputRemoveMargins = _this$props.inputRemoveMargins,
        invalid = _this$props.invalid,
        inverse = _this$props.inverse,
        loading = _this$props.loading,
        label = _this$props.label,
        labelDescription = _this$props.labelDescription,
        large = _this$props.large,
        maxResults = _this$props.maxResults,
        name = _this$props.name,
        noResultsLabel = _this$props.noResultsLabel,
        onBlur = _this$props.onBlur,
        onCancel = _this$props.onCancel,
        onChange = _this$props.onChange,
        onFocus = _this$props.onFocus,
        onSelect = _this$props.onSelect,
        onSubmit = _this$props.onSubmit,
        placeholder = _this$props.placeholder,
        prefix = _this$props.prefix,
        results = _this$props.results,
        resultsBorderless = _this$props.resultsBorderless,
        resultsMaxHeight = _this$props.resultsMaxHeight,
        resultsPosition = _this$props.resultsPosition,
        resultsWidth = _this$props.resultsWidth,
        scrollResults = _this$props.scrollResults,
        showFakeValuePlaceholder = _this$props.showFakeValuePlaceholder,
        small = _this$props.small,
        subResultPaddingUnits = _this$props.subResultPaddingUnits,
        underlineFocus = _this$props.underlineFocus;
    return /*#__PURE__*/_react.default.createElement(_reactOutsideClickHandler.default, null, /*#__PURE__*/_react.default.createElement(_Input.default, {
      autoComplete: "off",
      autoFocus: autoFocus,
      book: book,
      borderless: inputBorderless,
      disabled: disabled //errorMessage={errorMessage}
      ,
      focusBorderless: inputFocusBorderless,
      hideLabel: hideLabel,
      id: id,
      inline: inline,
      inputRef: inputRef,
      invalid: invalid,
      inverse: inverse,
      label: label,
      labelDescription: labelDescription,
      large: large,
      name: name //onBlur={onBlur}
      //onChange={onChange}
      //onClear={onClear}
      //onFocus={onFocus}
      //onKeyDown={onKeyDown}
      ,
      placeholder: placeholder,
      prefix: prefix //refForFocus={refForFocus}
      ,
      removeMargins: inputRemoveMargins,
      showFakeValuePlaceholder: showFakeValuePlaceholder,
      showOverflowEllipsis: inputOverflowEllipsis,
      small: small,
      type: "text",
      underlineFocus: underlineFocus,
      value: this.state.value
    }));
  };

  return Autocomplete;
}(_react.Component);

exports.Autocomplete = Autocomplete;
Autocomplete.propTypes = propTypes;