"use strict";

exports.__esModule = true;
exports.default = exports.Avatar = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var propTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  inline: _propTypes.default.bool,
  large: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  source: _propTypes.default.string,
  square: _propTypes.default.bool,
  size: _propTypes.default.number
});

var Avatar = function Avatar(_ref) {
  var css = _ref.css,
      inline = _ref.inline,
      large = _ref.large,
      loading = _ref.loading,
      micro = _ref.micro,
      size = _ref.size,
      small = _ref.small,
      source = _ref.source,
      square = _ref.square,
      styles = _ref.styles;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.avatar, inline && styles.avatar_inline, large && styles.avatar_large, micro && styles.avatar_micro, small && styles.avatar_small, square && styles.avatar_square, !micro && !small && !large && !size && styles.avatar_medium, {
    backgroundImage: "url(" + source + ")",
    width: size,
    height: size
  }), loading && /*#__PURE__*/_react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  }));
};

Avatar.propTypes = propTypes;
var AvatarWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    avatar: {
      borderRadius: '50%',
      overflow: 'hidden',
      backgroundSize: 'cover',
      backgroundColor: color.gray,
      backgroundPosition: 'center'
    },
    avatar_inline: {
      display: 'inline-block'
    },
    avatar_micro: {
      width: units(1.5),
      height: units(1.5)
    },
    avatar_small: {
      width: units(2.5),
      height: units(2.5)
    },
    avatar_medium: {
      width: units(3.5),
      height: units(3.5)
    },
    avatar_large: {
      width: units(5),
      height: units(5)
    },
    avatar_square: {
      borderRadius: radius
    }
  };
})(Avatar);
exports.Avatar = AvatarWithStyles;
var _default = AvatarWithStyles;
exports.default = _default;