"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _Button = _interopRequireDefault(require("./Button"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var dropdownPropTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  block: _propTypes.default.bool,
  bottom: _propTypes.default.bool,
  combo: _propTypes.default.bool,
  compact: _propTypes.default.bool,
  container: _propTypes.default.bool,
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  inverse: _propTypes.default.bool,
  isOpen: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  mountOnEnter: _propTypes.default.bool,
  unmountOnExit: _propTypes.default.bool,
  noBorder: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  shade: _propTypes.default.bool,
  soft: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  rectangular: _propTypes.default.bool,
  removeIcon: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  side: _propTypes.default.bool,
  short: _propTypes.default.bool,
  transparent: _propTypes.default.bool,
  children: _propTypes.default.node,
  button: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  only: _propTypes.default.bool,
  relative: _propTypes.default.bool,
  left: _propTypes.default.bool,
  options: _propTypes.default.arrayOf(_propTypes.default.object),
  onSelectOption: _propTypes.default.func,
  closeOnSelect: _propTypes.default.bool,
  small: _propTypes.default.bool,
  large: _propTypes.default.bool,
  tall: _propTypes.default.bool,
  wide: _propTypes.default.bool
});

var dropdownMenuPropTypes = _extends({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any.isRequired,
  left: _propTypes.default.bool,
  isOpen: _propTypes.default.bool,
  insideAButton: _propTypes.default.bool
});

var dropdownDefaultProps = {
  options: [],
  isOpen: false,
  removeIcon: false
};

var Dropdown = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Dropdown, _Component);

  function Dropdown(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      isOpen: props.isOpen,
      closedByOutsideClick: false
    };
    return _this;
  }

  var _proto = Dropdown.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.isOpen !== this.props.isOpen) {
      this.setState({
        isOpen: this.props.isOpen
      });
    }

    if (prevState.isOpen !== this.state.isOpen) {
      this.props.onToggleMenu && this.props.onToggleMenu(this.state.isOpen);
    }
  };

  _proto.toggleMenu = function toggleMenu() {
    this.setState(function (_ref) {
      var isOpen = _ref.isOpen,
          closedByOutsideClick = _ref.closedByOutsideClick;
      return closedByOutsideClick && !isOpen ? {
        closedByOutsideClick: false
      } : {
        isOpen: !isOpen
      };
    });
  };

  _proto.closeMenu = function closeMenu() {
    this.setState(function (_ref2) {
      var isOpen = _ref2.isOpen,
          closedByOutsideClick = _ref2.closedByOutsideClick;
      return closedByOutsideClick && !isOpen ? {
        closedByOutsideClick: false
      } : {
        isOpen: false
      };
    });
  };

  _proto.onClickOutsideMenu = function onClickOutsideMenu() {
    this.setState(function (state) {
      return {
        isOpen: false,
        closedByOutsideClick: state.isOpen
      };
    });
  };

  _proto.onSelectOption = function onSelectOption(option) {
    this.props.onSelectOption && this.props.onSelectOption(option);
    this.props.closeOnSelect && this.toggleMenu();
  };

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        styles = _this$props.styles,
        button = _this$props.button,
        bottom = _this$props.bottom,
        container = _this$props.container,
        label = _this$props.label,
        children = _this$props.children,
        only = _this$props.only,
        relative = _this$props.relative,
        left = _this$props.left,
        options = _this$props.options,
        disabled = _this$props.disabled,
        loading = _this$props.loading,
        fullWidth = _this$props.fullWidth,
        block = _this$props.block,
        combo = _this$props.combo,
        compact = _this$props.compact,
        icon = _this$props.icon,
        inverse = _this$props.inverse,
        mono = _this$props.mono,
        mountOnEnter = _this$props.mountOnEnter,
        unmountOnExit = _this$props.unmountOnExit,
        noBorder = _this$props.noBorder,
        noSpacing = _this$props.noSpacing,
        shade = _this$props.shade,
        side = _this$props.side,
        soft = _this$props.soft,
        shimmer = _this$props.shimmer,
        primary = _this$props.primary,
        rectangular = _this$props.rectangular,
        removeIcon = _this$props.removeIcon,
        secondary = _this$props.secondary,
        short = _this$props.short,
        transparent = _this$props.transparent,
        small = _this$props.small,
        wide = _this$props.wide,
        tall = _this$props.tall,
        large = _this$props.large;
    return container ? /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.dropdown__container, styles.dropdown__container_noSpacing, styles.dropdown__container_relative), /*#__PURE__*/_react.default.createElement("div", {
      onClick: function onClick() {
        return _this2.toggleMenu();
      }
    }, children), /*#__PURE__*/_react.default.createElement(DropdownMenuWithStyles, {
      isOpen: this.state.isOpen,
      onClickOutside: function onClickOutside() {
        return _this2.onClickOutsideMenu();
      },
      left: left,
      side: side,
      bottom: bottom,
      mountOnEnter: mountOnEnter,
      unmountOnExit: unmountOnExit
    }, /*#__PURE__*/_react.default.createElement("ul", (0, _withStyles.css)(styles.dropdown__list), options && options.map(function (option) {
      return /*#__PURE__*/_react.default.createElement("li", _extends({
        key: option.value
      }, (0, _withStyles.css)(styles.dropdown__list__item)), /*#__PURE__*/_react.default.createElement(_Button.default, {
        short: true,
        compact: true,
        inverse: true,
        noSpacing: true,
        block: true,
        onClick: function onClick() {
          return _this2.onSelectOption(option);
        }
      }, option.label));
    })))) : /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.dropdown__container, button && styles.dropdown__container_asAButton, noSpacing && styles.dropdown__container_noSpacing, !combo && (container || button || only || relative) && styles.dropdown__container_relative), button ? /*#__PURE__*/_react.default.createElement(_Button.default, _extends({
      noSpacing: true,
      disabled: disabled,
      loading: loading,
      shimmer: shimmer,
      fullWidth: fullWidth,
      block: block,
      compact: compact,
      inverse: inverse,
      mono: mono,
      noBorder: noBorder,
      soft: soft,
      primary: primary,
      rectangular: rectangular,
      secondary: secondary,
      shade: shade,
      short: short,
      transparent: transparent,
      small: small,
      wide: wide,
      tall: tall,
      large: large,
      type: "button",
      onClick: function onClick() {
        return _this2.toggleMenu();
      }
    }, (0, _withStyles.css)(styles.dropdown, styles.dropdown_asAButton)), label, !removeIcon && (icon ? typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Icon.default, {
      name: icon,
      primary: true,
      smaller: true,
      noPadding: true
    }) : icon : /*#__PURE__*/_react.default.createElement("svg", _extends({}, (0, _withStyles.css)(styles.dropdown__arrow, label && styles.dropdown__arrow_leftMarged, mono && styles.dropdown__arrow_mono, (soft || inverse || transparent) && styles.dropdown__arrow_primary, secondary && styles.dropdown__arrow_secondary), {
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 10.4 6.3"
    }), /*#__PURE__*/_react.default.createElement("path", {
      d: "M5.2,6.3A.91.91,0,0,1,4.5,6L.3,1.8A1,1,0,0,1,.3.4,1,1,0,0,1,1.7.4L5.2,3.9,8.7.3a1,1,0,0,1,1.4,0,1,1,0,0,1,0,1.4L5.9,6a4.88,4.88,0,0,1-.7.3Z"
    })))) : /*#__PURE__*/_react.default.createElement("button", _extends({
      type: "button",
      onClick: function onClick() {
        return _this2.toggleMenu();
      }
    }, (0, _withStyles.css)(styles.dropdown, only && styles.dropdown_only)), /*#__PURE__*/_react.default.createElement("svg", _extends({}, (0, _withStyles.css)(styles.dropdown__arrow, mono && styles.dropdown__arrow_mono, (soft || inverse || transparent || primary) && styles.dropdown__arrow_primary, secondary && styles.dropdown__arrow_secondary), {
      xmlns: "http://www.w3.org/2000/svg",
      viewBox: "0 0 10.4 6.3"
    }), /*#__PURE__*/_react.default.createElement("path", {
      d: "M5.2,6.3A.91.91,0,0,1,4.5,6L.3,1.8A1,1,0,0,1,.3.4,1,1,0,0,1,1.7.4L5.2,3.9,8.7.3a1,1,0,0,1,1.4,0,1,1,0,0,1,0,1.4L5.9,6a4.88,4.88,0,0,1-.7.3Z"
    }))), /*#__PURE__*/_react.default.createElement(DropdownMenuWithStyles, {
      isOpen: this.state.isOpen,
      onClickOutside: function onClickOutside() {
        return _this2.onClickOutsideMenu();
      },
      insideAButton: button,
      combo: combo,
      left: left,
      side: side,
      bottom: bottom,
      mountOnEnter: mountOnEnter,
      unmountOnExit: unmountOnExit
    }, children ? children : /*#__PURE__*/_react.default.createElement("ul", (0, _withStyles.css)(styles.dropdown__list), options.map(function (option) {
      return /*#__PURE__*/_react.default.createElement("li", _extends({
        key: option.value
      }, (0, _withStyles.css)(styles.dropdown__list__item)), /*#__PURE__*/_react.default.createElement(_Button.default, {
        short: true,
        compact: true,
        inverse: true,
        noSpacing: true,
        block: true,
        onClick: function onClick() {
          return _this2.onSelectOption(option);
        }
      }, option.label));
    }))));
  };

  return Dropdown;
}(_react.Component);

var DropdownMenu = /*#__PURE__*/function (_Component2) {
  _inheritsLoose(DropdownMenu, _Component2);

  function DropdownMenu() {
    return _Component2.apply(this, arguments) || this;
  }

  var _proto2 = DropdownMenu.prototype;

  _proto2.render = function render() {
    var _this$props2 = this.props,
        bottom = _this$props2.bottom,
        children = _this$props2.children,
        combo = _this$props2.combo,
        left = _this$props2.left,
        isOpen = _this$props2.isOpen,
        insideAButton = _this$props2.insideAButton,
        mountOnEnter = _this$props2.mountOnEnter,
        unmountOnExit = _this$props2.unmountOnExit,
        side = _this$props2.side,
        styles = _this$props2.styles,
        onClickOutside = _this$props2.onClickOutside;
    return /*#__PURE__*/_react.default.createElement(_reactOutsideClickHandler.default, {
      onOutsideClick: function onOutsideClick() {
        return onClickOutside();
      }
    }, /*#__PURE__*/_react.default.createElement(_Transition.default, {
      in: isOpen,
      timeout: 300,
      mountOnEnter: mountOnEnter,
      unmountOnExit: unmountOnExit,
      onEnter: function onEnter(node) {
        return node.scrollTop;
      }
    }, function (state) {
      return /*#__PURE__*/_react.default.createElement("div", (0, _withStyles.css)(styles.dropdownMenu, !combo && insideAButton && styles.dropdownMenu_insideAButton, left && !side && styles.dropdownMenu_left, !left && !side && styles.dropdownMenu_right, left && side && styles.dropdownMenu_leftSide, !left && side && styles.dropdownMenu_rightSide, side && (bottom ? styles.dropdownMenu_sideBottom : styles.dropdownMenu_sideTop), (state === 'entering' || state === 'entered') && styles.dropdownMenu_entering, (state === 'exiting' || state === 'exited') && styles.dropdownMenu_exiting), children);
    }));
  };

  return DropdownMenu;
}(_react.Component);

Dropdown.propTypes = dropdownPropTypes;
Dropdown.defaultProps = dropdownDefaultProps;
DropdownMenu.propTypes = dropdownMenuPropTypes;
var DropDownWithStyles = (0, _withStyles.withStyles)(function (_ref3) {
  var color = _ref3.color,
      units = _ref3.units;
  return {
    dropdown: {
      minWidth: units(1.5),
      minHeight: units(1.5),
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      outline: 'none',
      cursor: 'pointer',
      borderWidth: 0,
      background: color.transparent
    },
    dropdown_asAButton: {
      margin: 0
    },
    dropdown_only: {
      minWidth: units(2.5),
      height: units(2.5)
    },
    dropdown__arrow: {
      width: units(.5),
      fill: color.white
    },
    dropdown__arrow_leftMarged: {
      marginLeft: units(.75)
    },
    dropdown__arrow_rightMarged: {
      marginRight: units(.75)
    },
    dropdown__arrow_mono: {
      fill: color.black
    },
    dropdown__arrow_primary: {
      fill: color.primary
    },
    dropdown__arrow_secondary: {
      fill: color.secondary
    },
    dropdown_disabled: {
      opacity: .5,
      pointerEvents: 'none'
    },
    dropdown__container: {
      display: 'inline-block',
      boxSizing: 'border-box',
      maxWidth: '100%'
    },
    dropdown__container_relative: {
      position: 'relative'
    },
    dropdown__container_asAButton: {
      marginTop: 0,
      marginBottom: units(.5)
    },
    dropdown__container_noSpacing: {
      marginBottom: 0
    },
    dropdown__list: {
      margin: 0,
      padding: 0,
      listStyle: 'none'
    },
    dropdown__list__item: {}
  };
})(Dropdown);
var DropdownMenuWithStyles = (0, _withStyles.withStyles)(function (_ref4) {
  var color = _ref4.color,
      units = _ref4.units,
      radius = _ref4.radius;
  return {
    dropdownMenu: {
      position: 'absolute',
      marginTop: units(.25),
      top: '100%',
      backgroundColor: color.white,
      boxShadow: "0 " + units(0.5) + " " + units(0.75) + " " + units(-0.45) + " " + color.shadow,
      padding: units(0.5),
      borderRadius: radius,
      borderWidth: 1,
      borderStyle: 'solid',
      borderColor: color.blueGrayLight,
      zIndex: 50,
      opacity: 0.01,
      transform: 'translate(0, -10%)',
      transition: 'opacity 200ms ease-out, transform 300ms ease-out',
      pointerEvents: 'none'
    },
    dropdownMenu_left: {
      left: 0
    },
    dropdownMenu_right: {
      right: 0
    },
    dropdownMenu_leftSide: {
      right: '100%',
      marginTop: 0,
      marginRight: units(.25)
    },
    dropdownMenu_rightSide: {
      left: '100%',
      marginTop: 0,
      marginLeft: units(.25)
    },
    dropdownMenu_sideBottom: {
      top: 'unset',
      bottom: 0
    },
    dropdownMenu_sideTop: {
      top: 0
    },
    dropdownMenu_insideAButton: {
      marginRight: units(0.125),
      marginLeft: units(0.125)
    },
    //transitions
    dropdownMenu_entering: {
      opacity: 1,
      transform: 'translate(0, 0)',
      transition: 'opacity 200ms ease-out, transform 300ms ease-out',
      pointerEvents: 'auto'
    },
    dropdownMenu_exiting: {
      opacity: 0.01,
      transform: 'translate(0, -10%)',
      transition: 'opacity 200ms ease-out, transform 300ms ease-out',
      pointerEvents: 'none'
    }
  };
}, {
  flushBefore: true
})(DropdownMenu);
var _default = DropDownWithStyles;
exports.default = _default;