"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactGoogleMaps = require("react-google-maps");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var defaultProps = {
  center: {
    lat: -19.9322014,
    lng: -43.9246216
  },
  radius: 50,
  options: {
    fillColor: '#ee430e',
    strokeColor: '#ee430e',
    strokeWeight: 1,
    fillOpacity: .3,
    strokeOpacity: .5
  }
};

var MapCircle = /*#__PURE__*/function (_Component) {
  _inheritsLoose(MapCircle, _Component);

  function MapCircle() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = MapCircle.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        center = _this$props.center,
        draggable = _this$props.draggable,
        editable = _this$props.editable,
        _onCenterChanged = _this$props.onCenterChanged,
        _onClick = _this$props.onClick,
        _onDragEnd = _this$props.onDragEnd,
        _onMouseOut = _this$props.onMouseOut,
        _onMouseOver = _this$props.onMouseOver,
        _onRadiusChanged = _this$props.onRadiusChanged,
        options = _this$props.options,
        radius = _this$props.radius,
        removeMarker = _this$props.removeMarker;
    return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Circle, {
      ref: function ref(circle) {
        return _this.circle = circle;
      },
      center: center,
      radius: radius,
      options: options,
      draggable: draggable,
      editable: editable,
      onCenterChanged: function onCenterChanged() {
        return _this.circle && _onCenterChanged && _onCenterChanged(_this.circle.getCenter());
      },
      onDragEnd: function onDragEnd() {
        return _this.circle && _onDragEnd && _onDragEnd(_this.circle.getCenter());
      },
      onRadiusChanged: function onRadiusChanged() {
        return _this.circle && _onRadiusChanged && _onRadiusChanged(_this.circle.getRadius());
      },
      onClick: function onClick() {
        return _onClick && _onClick();
      },
      onMouseOut: function onMouseOut() {
        return _onMouseOut && _onMouseOut();
      },
      onMouseOver: function onMouseOver() {
        return _onMouseOver && _onMouseOver();
      }
    }), !removeMarker && /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Marker, {
      position: center,
      visible: false
    }));
  };

  return MapCircle;
}(_react.Component);

MapCircle.defaultProps = defaultProps;
var _default = MapCircle;
exports.default = _default;