"use strict";

exports.__esModule = true;
exports.Tabs = exports.TabCustomTrigger = exports.TabButton = exports.Tab = void 0;

var _react = _interopRequireWildcard(require("react"));

var _TabButton = _interopRequireDefault(require("./TabButton"));

var _excluded = ["children", "tabKey"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TabContext = /*#__PURE__*/_react.default.createContext({
  activeTab: null,
  setActiveTab: function setActiveTab() {}
});

var Tabs = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Tabs, _Component);

  function Tabs(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.setActiveTab = function (tab) {
      _this.setState({
        activeTab: tab
      });
    };

    _this.state = {
      activeTab: null,
      setActiveTab: _this.setActiveTab
    };
    return _this;
  }

  var _proto = Tabs.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var initialTab = this.props.initialTab;

    if (initialTab != null) {
      this.setActiveTab(initialTab);
    }
  };

  _proto.render = function render() {
    var children = this.props.children;
    return /*#__PURE__*/_react.default.createElement(TabContext.Provider, {
      value: this.state
    }, children);
  };

  return Tabs;
}(_react.Component);

exports.Tabs = Tabs;

var Tab = function Tab(_ref) {
  var children = _ref.children,
      tabKey = _ref.tabKey;
  return /*#__PURE__*/_react.default.createElement(TabContext.Consumer, null, function (_ref2) {
    var activeTab = _ref2.activeTab;
    return tabKey === activeTab && children;
  });
};

exports.Tab = Tab;

var TabButton = function TabButton(_ref3) {
  var children = _ref3.children,
      tabKey = _ref3.tabKey,
      props = _objectWithoutPropertiesLoose(_ref3, _excluded);

  return /*#__PURE__*/_react.default.createElement(TabContext.Consumer, null, function (_ref4) {
    var activeTab = _ref4.activeTab,
        setActiveTab = _ref4.setActiveTab;
    return /*#__PURE__*/_react.default.createElement(_TabButton.default, _extends({
      onClick: function onClick() {
        return setActiveTab(tabKey);
      },
      active: tabKey === activeTab
    }, props), children);
  });
};

exports.TabButton = TabButton;
var TabCustomTrigger = TabContext.Consumer;
exports.TabCustomTrigger = TabCustomTrigger;