"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var propTypes = {
  children: _propTypes.default.object.isRequired,
  debounceTimeoutMs: _propTypes.default.number,
  debouncedOnChange: _propTypes.default.func,
  throttleTimeoutMs: _propTypes.default.number,
  throttledOnChange: _propTypes.default.func
};

var ThrottledTextInput = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ThrottledTextInput, _Component);

  function ThrottledTextInput(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.debouncedOnChange = _lodash.default.debounce(_this.debouncedOnChange.bind(_assertThisInitialized(_this)), props.debounceTimeoutMs);
    _this.throttledOnChange = _lodash.default.throttle(_this.throttledOnChange.bind(_assertThisInitialized(_this)), props.throttleTimeoutMs);
    return _this;
  }

  var _proto = ThrottledTextInput.prototype;

  _proto.debouncedOnChange = function debouncedOnChange(value) {
    this.props.debouncedOnChange(value);
  };

  _proto.throttledOnChange = function throttledOnChange(value) {
    this.props.throttledOnChange(value);
  };

  _proto.onChange = function onChange(event) {
    var value = event.target.value;
    var _this$props = this.props,
        debounceTimeoutMs = _this$props.debounceTimeoutMs,
        debouncedOnChange = _this$props.debouncedOnChange,
        throttleTimeoutMs = _this$props.throttleTimeoutMs,
        throttledOnChange = _this$props.throttledOnChange;

    if (debouncedOnChange && debounceTimeoutMs) {
      this.debouncedOnChange(value);
    } else if (throttledOnChange && throttleTimeoutMs) {
      this.throttledOnChange(value);
    }
  };

  _proto.render = function render() {
    var children = this.props.children;
    return /*#__PURE__*/_react.default.cloneElement(_react.default.Children.only(children), {
      onChange: this.onChange
    });
  };

  return ThrottledTextInput;
}(_react.Component);

ThrottledTextInput.propTypes = propTypes;
var _default = ThrottledTextInput;
exports.default = _default;